#ifndef frame_parser_header
#define frame_parser_header

#include "stdint.h"
#include "stdlib.h"
#include "string.h"
#include "main.h"
#include "ws2812b.h"

struct frame_parser_state {
	ws2812b_config * led_strip_handler;
	uint8_t diodes_count;
	uint8_t line_buffer[800];
	uint8_t writer_position;
	uint8_t reader_position;
	uint8_t field_buffer[30];
	uint8_t field_position;
	uint8_t process_frame;
};

struct frame_parser_state frame_parser_init(ws2812b_config * _led_strip_handler, uint8_t _diodes_count);
void frame_parser_recv_char(struct frame_parser_state * state, uint8_t recv_char);
void frame_parser_read_field(struct frame_parser_state * state);
void frame_parser_process_frame(struct frame_parser_state * state);

#endif
